module.exports = {

    'exists' : function(check) {
        return check('mario.c exists')
        .exists('mario.c');
    },

    'compiles' : function(check) {
        return check('mario.c compiles')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0);
    },

    'height of -1' : ['compiles', function(check) {
        return check('rejects a height of -1')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('-1\n')
        .stdout(/[\s\S]*/);
    }],

    'height of 0' : ['compiles', function(check) {
        return check('handles a height of 0 correctly')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('0\n')
        .exit(0);
    }],
 
    'height of 1' : ['compiles', function(check) {
        return check('handles a height of 1 correctly')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('1\n')
        .stdout('./mario-1.txt')
        .exit(0);
    }],

    'height of 2' : ['compiles', function(check) {
        return check('handles a height of 2 correctly')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('2\n')
        .stdout('./mario-2.txt')
        .exit(0);
    }],

    'height of 23' : ['compiles', function(check) {
        return check('handles a height of 23 correctly')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('23\n')
        .stdout('./mario-23.txt')
        .exit(0);
    }],

    'height of 24' : ['compiles', function(check) {
        return check('rejects a height of 24')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('24\n')
        .stdout(/[\s\S]*/)
        .stdin();
    }],

    'height of "foo"' : ['compiles', function(check) {
        return check('rejects a non-numeric height of "foo"')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('foo\n')
        .stdout(/[\s\S]*/);
    }],

    'height of ""' : ['compiles', function(check) {
        return check('rejects a non-numeric height of ""')
        .run('clang -o mario mario.c -lcs50 -lm')
        .exit(0)
        .run('./mario')
        .stdout(/[\s\S]*/)
        .stdin('\n')
        .stdout(/[\s\S]*/);
    }]

};
